var params = location.search.substring(1).split('&');
var param = params[0].split('=');

var loadIndex = function() {
	if(param.length > 1) {
		if(param[0] == "p") {
			getRestaurants();
		}
		
		if(param[0] == "msg") {
			var msg = '<div class="alert alert-success" role="alert"><b><span class="glyphicon glyphicon-ok" aria-hidden="true"></span> Ajout du restaurant réussi !</b></div>';
			
			if(param[1] == "modification") {
				msg = '<div class="alert alert-success" role="alert"><b><span class="glyphicon glyphicon-ok" aria-hidden="true"></span> Modification du restaurant réussie !</b></div>';
			}
			
			document.querySelector("#info").innerHTML = msg;
			getRestaurants();
		}
	}
}

var connectMongoDB = function() {
	ajaxRequest('GET', 'api/connect', null, function(res) {
		document.querySelector("#info").innerHTML = '<div class="alert alert-success" role="alert"><b><span class="glyphicon glyphicon-ok" aria-hidden="true"></span> '+res.message+'</b></div>';
	});
};

var countRestaurants = function(callback) {
	ajaxRequest('GET', 'api/countRestaurants', null, function(res) {
		callback(res.data);
	});
};

var getRestaurants = function() {
	var p = 1;
	
	if(param.length > 1 && param[0] == "p") {
		if(Number.isInteger(parseInt(param[1]))) {
			p = param[1];
		}
		if(p <= 0) {
			p = 1;
		}
	}

	ajaxRequest('GET', 'api/getRestaurants/'+p, null, function(res) {
		var restaurantsHTML = document.querySelector("#restaurants");
	
		var html = '<table class="table table-hover">';
		html += "<thead><tr><th>Nom du restaurant</th><th>Type de cuisine</th><th>Lieu</th></tr></thead>";
		
		for(var i=0; i < res.data.length; i++) {
			html += "<tr>";
			html += "<td>"+res.data[i].name+"</td>";
			html += "<td>"+res.data[i].cuisine+"</td>";
			html += "<td>"+res.data[i].borough+"</td>";
			html += "<td class='text-center col-sm-1'><a class='btn btn-success' href='view_restaurant.html?id="+res.data[i].restaurant_id+"'><span class='glyphicon glyphicon-search' aria-hidden='true'></span></a></td>";
			html += "<td class='text-center col-sm-1'><a class='btn btn-warning' href='restaurant.html?id="+res.data[i].restaurant_id+"'><span class='glyphicon glyphicon-pencil' aria-hidden='true'></span></a></td>";
			html += '<td class="text-center col-sm-1"><button type="button" class="btn btn-danger" onclick="delRestaurant(\''+res.data[i].restaurant_id+'\')"><span class="glyphicon glyphicon-trash" aria-hidden="true"></span></button></td>';
			html += "</tr>";
		}

		html += "</table>";
		
		restaurantsHTML.innerHTML = html;
		
		countRestaurants(function(nb) {
			var paginationHTML = document.querySelector("#pagination");
			var nbPage = Math.ceil(nb / 10);
			var html = '<nav aria-label="Page navigation"><ul class="pagination">';
			var start = parseInt(p) - 10;
			var end = parseInt(p) + 10;
			
			for(var i=0; i<nbPage; i++) {
				var curPage = i + 1;
				if(i==0 || curPage==nbPage || (curPage>=start && curPage<=end)) {
					html += '<li';
					if(curPage==p) {
						html += ' class="active"';
					}
					html += '><a href="/?p='+curPage+'">'+curPage+'</a></li>';
				}
			}
			
			html += '</ul></nav>';
			
			paginationHTML.innerHTML = html;
		});		
	});
};

var getViewRestaurant = function() {
	if(param.length > 1 && param[0] == "id" && param[1] != "") {		
		ajaxRequest('GET', 'api/getRestaurant/'+param[1]+'/1', null, function(res) {			
			document.querySelector('#view_restaurant').innerHTML = '<div class="panel panel-primary"><div class="panel-heading"><h3 class="panel-title">Informations du restaurant</h3></div>'+forEach(res.data[0])+'</div>';
		});
	}
};

var getRestaurant = function() {
	if(param.length > 1 && param[0] == "id" && param[1] != "") {
		document.querySelector('form').setAttribute("onsubmit", "updRestaurant(this)");
		document.querySelector('input[name="restaurant_id"]').setAttribute("readonly", "");
		
		ajaxRequest('GET', 'api/getRestaurant/'+param[1], null, function(res) {
			document.querySelector('input[name="restaurant_id"]').setAttribute("value", res.data[0].restaurant_id);
			document.querySelector('input[name="name"]').setAttribute("value", res.data[0].name);
			document.querySelector('input[name="cuisine"]').setAttribute("value", res.data[0].cuisine);
			document.querySelector('input[name="borough"]').setAttribute("value", res.data[0].borough);
			document.querySelector('input[name="address[building]"]').setAttribute("value", res.data[0].address.building);
			document.querySelector('input[name="address[street]"]').setAttribute("value", res.data[0].address.street);
			document.querySelector('input[name="address[zipcode]"]').setAttribute("value", res.data[0].address.zipcode);
		});
	}
};

var addRestaurant = function(form) {
	var formData = new FormData(form);

	ajaxRequest('POST', 'api/addRestaurant', formData, function(res) {
		location.href = res.redirect;
	});
}

var updRestaurant = function(form) {
	var formData = new FormData(form);
	
	ajaxRequest('PUT', 'api/updRestaurant', formData, function(res) {
		location.href = res.redirect;
	});
};

var delRestaurant = function(id) {
	ajaxRequest('DELETE', 'api/delRestaurant/'+id, null, function(res) {
		document.querySelector("#info").innerHTML = '<div class="alert alert-success" role="alert"><b><span class="glyphicon glyphicon-ok" aria-hidden="true"></span> '+res.message+'</b></div>';
		getRestaurants();
	});
};

var ajaxRequest = function(type, url, params, callback) {
	var xhr = new XMLHttpRequest();
	xhr.open(type, url, true);
	xhr.responseType = 'json';

	xhr.send(params);
	xhr.onload = function() {
		callback(this.response);
	};
};

var forEach = function(obj) {
	var html = '<div class="panel panel-body">';
	for(var k in obj) {
		if(obj.hasOwnProperty(k) && typeof obj[k] !== 'object') {
			html += "<b>"+k+":</b> "+obj[k]+'<br>';
		}
	}

	for(var k in obj) {
		if(typeof obj[k] === 'object') {
			html += '<div class="panel panel-primary"><div class="panel-heading"><h3 class="panel-title">'+k+'</h3></div>';
			html += forEach(obj[k]);
		}
	}
	
	html += "</div></div>";
	
	return html;
};